#ifdef __cplusplus
extern "C" {
#endif
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#include <stdio.h>
#include <stdlib.h>
#ifdef __cplusplus
}
#endif

#include <string.h>
#include <ggi/ggi.h>

MODULE = GGI::Color		PACKAGE = GGI::Color		

PROTOTYPES: DISABLE

int
COLOR_PRECISION()
	CODE:
	RETVAL = (GGI_COLOR_PRECISION);
	OUTPUT:
	RETVAL

ggi_color *
_malloc(discard, ncols)
	void *		discard
	size_t		ncols
	CODE:
	RETVAL = malloc(ncols * sizeof(ggi_color));
	OUTPUT:
	RETVAL

ggi_color *
_calloc(discard, ncols)
	void *		discard
	size_t		ncols
	CODE:
	RETVAL = calloc(ncols, sizeof(ggi_color));
	OUTPUT:
	RETVAL

void
_free(discard, buff)
	void *		discard
	void *		buff
	CODE:
	free(buff);

ggi_color *
_realloc(discard, buff, num, was)
	void *		discard
	void *		buff
	size_t		num
	size_t		was
	CODE:
	RETVAL = realloc(buff, num * sizeof(ggi_color));
	if (RETVAL == NULL) {
		num = was;
		RETVAL = buff;
	}
	if (num > was) {
		memset(buff + was, 0, (num - was) * sizeof(ggi_color));
	}
	OUTPUT:
	RETVAL
	num

ggi_color *
_realloc_noclear(discard, buff, num, was)
	void *		discard
	void *		buff
	size_t		num
	size_t		was
	CODE:
	RETVAL = realloc(buff, num * sizeof(ggi_color));
	if (RETVAL == NULL) {
		num = was;
		RETVAL = buff;
	}
	OUTPUT:
	RETVAL
	num


void
_get_fwd(discard, buff, csel, idx, num)
	void *		discard
	ggi_color *	buff	
	char *		csel
	size_t		idx
	size_t		num
	PPCODE:
	EXTEND(sp, num * strlen(csel));
	while(num--) {
		int csel_idx;
		for (csel_idx = 0; csel_idx < strlen(csel); csel_idx++) {
			switch(*(csel + csel_idx)) {
			case 'r': 
				PUSHs(sv_2mortal(newSViv((buff + idx)->r)));
				break;
			case 'g': 
				PUSHs(sv_2mortal(newSViv((buff + idx)->g)));
				break;
			case 'b': 
				PUSHs(sv_2mortal(newSViv((buff + idx)->b)));
				break;
			case 'a': 
				PUSHs(sv_2mortal(newSViv((buff + idx)->a)));
				break;
			default:
				PUSHs(sv_newmortal());
			}
		}		
		idx++;
	}


void
_get_rev(discard, buff, csel, idx, num)
	void *		discard
	ggi_color *	buff	
	char *		csel
	size_t		idx
	size_t		num
	PPCODE:
	EXTEND(sp, num * strlen(csel));
	while(num--) {
		int csel_idx;
		for (csel_idx = 0; csel_idx < strlen(csel); csel_idx++) {
			switch(*(csel + csel_idx)) {
			case 'r': 
				PUSHs(sv_2mortal(newSViv((buff + idx)->r)));
				break;
			case 'g': 
				PUSHs(sv_2mortal(newSViv((buff + idx)->g)));
				break;
			case 'b': 
				PUSHs(sv_2mortal(newSViv((buff + idx)->b)));
				break;
			case 'a': 
				PUSHs(sv_2mortal(newSViv((buff + idx)->a)));
				break;
			default:
				PUSHs(sv_newmortal());
			}
		}		
		idx--;
	}



size_t
_set_fwd(discard, buff, csel, idx, lidx, num, arg)
	void *		discard
	ggi_color *	buff	
	char *		csel
	int		idx
	size_t		lidx
	size_t		num
	SV*		arg
	PREINIT:
	size_t		cnum, snum, didx, cidx;
	CODE:
	didx = 0;
	cnum = strlen(csel);
	snum = num/cnum + (num % cnum ? 1 : 0);
	RETVAL = idx + snum;
	if (idx < 0) {
		if (RETVAL > 0) {
			didx = -idx * cnum;
			num += didx;
			idx = 0;
                }
		else {
			num = 0;
		}
	}
	cidx = 0;
	while((num--) && (idx <= lidx)) {
		switch(*(csel + cidx)) {
		case 'r': 
			(buff + idx)->r = 
				(uint16) SvIV(*(av_fetch((AV*)SvRV(arg), didx, 0)));
			break;
		case 'g': 
			(buff + idx)->g = 
				(uint16) SvIV(*(av_fetch((AV*)SvRV(arg), didx, 0)));
			break;
		case 'b': 
			(buff + idx)->b = 
				(uint16) SvIV(*(av_fetch((AV*)SvRV(arg), didx, 0)));
			break;
		case 'a': 
			(buff + idx)->a = 
				(uint16) SvIV(*(av_fetch((AV*)SvRV(arg), didx, 0)));
			break;
		default:
			break;
		}
		didx++;
		cidx++;
		if(! (cidx %= cnum)) idx++;
	}
	OUTPUT:
	RETVAL


size_t
_set_rev(discard, buff, csel, idx, lidx, num, arg)
	void *		discard
	ggi_color *	buff	
	char *		csel
	int		idx
	size_t		lidx
	size_t		num
	SV*		arg
	PREINIT:
	size_t		cnum, snum, didx, cidx;
	CODE:
	didx = 0;
	cnum = strlen(csel);
	snum = num/cnum + (num % cnum ? 1 : 0);
	RETVAL = idx - snum;
	if (idx > lidx) {
		if (RETVAL < lidx) {
			didx = (idx - lidx) * cnum;
			idx = lidx;
                }
		else {
			num = 0;
		}
	}
	cidx = 0;
	while((num--) && (idx >= 0)) {
		switch(*(csel + cidx)) {
		case 'r': 
			(buff + idx)->r = 
				(uint16) SvIV(*(av_fetch((AV*)SvRV(arg), didx, 0)));
			break;
		case 'g': 
			(buff + idx)->g = 
				(uint16) SvIV(*(av_fetch((AV*)SvRV(arg), didx, 0)));
			break;
		case 'b': 
			(buff + idx)->b = 
				(uint16) SvIV(*(av_fetch((AV*)SvRV(arg), didx, 0)));
			break;
		case 'a': 
			(buff + idx)->a = 
				(uint16) SvIV(*(av_fetch((AV*)SvRV(arg), didx, 0)));
			break;
		default:
			break;
		}
		didx++;
		cidx++;
		if(! (cidx %= cnum)) idx--;
	}
	OUTPUT:
	RETVAL